## snes9x 1.16a

=== Makefile ===
ZSNESFX=1
ASMCPU=1
#SPC700ASM=1
NETPLAY=1
UNZIP=1

ifdef ZSNESFX
FXOBJ=i386/zsnes.o
FXDEFINES=-DZSNES_FX -DEXECUTE_SUPERFX_PER_LINE
FXDEPENDS=zsnes_fx
FXNO_DEPENDS=c_fx
else
FXOBJ=fxinst.o fxemu.o fxdbg.o
FXDEFINES=-DEXECUTE_SUPERFX_PER_LINE
FXDEPENDS=c_fx
FXNO_DEPENDS=zsnes_fx
endif

LINUXDEFINES=-DUSE_DGA_EXTENSION -DUSE_VIDMODE_EXTENSION

ifdef ASMCPU
ifdef SPC700ASM
CPUOBJ=i386/cpuops.o i386/cpuexec.o i386/spc700.o
CPUDEFINES=
else
CPUOBJ=i386/cpuops.o i386/cpuexec.o spc700.o
CPUDEFINES=-DSPC700_C
endif
else
CPUOBJ=cpuops.o cpuexec.o spc700.o
CPUDEFINES=
endif

OBJECTS=$(CPUOBJ) cpu.o debug.o tile.o \
	gfx.o memmap.o snaporig.o clip.o dsp1.o \
	ppu.o dma.o snes9x.o snapshot.o apu.o soundux.o \
        cheats.o data.o globals.o unix/unix.o unix/config.o $(FXOBJ)

ifdef NETPLAY
OBJECTS += netplay.o
NETPLAYDEFINES=-DNETPLAY_SUPPORT
SERVER_OBJECTS=server.o
endif

ifdef UNZIP
OBJECTS += loadzip.o unzip/unzip.o
UNZIPDEFINES=-DUNZIP_SUPPORT
endif

CCC = gcc
CC = gcc
NASM = nasm

INCLUDES=-I/usr/X11R6/include -I/usr/local/include

OPTIMISE=-O6 -mpentium -fomit-frame-pointer -fno-exceptions -fno-rtii
#OPTIMISE=-g

CCFLAGS = $(OPTIMISE) -DMITSHM \
-fno-exceptions \
-Ii386 \
-I. \
-Iunzip \
-DJOYSTICK_SUPPORT \
-DZLIB \
-DNO_INLINE_SET_GET \
-DVAR_CYCLES \
-DDEBUGGER \
-DCPU_SHUTDOWN \
-DSPC700_SHUTDOWN \
$(LINUXDEFINES) \
$(FXDEFINES) \
$(CPUDEFINES) \
$(NETPLAYDEFINES) \
$(UNZIPDEFINES)

#-DEXECUTE_SUPERFX_PER_LINE
#-DSOUND
#-DDEBUGGER
#-DNO_INLINE_SET_GET
#-DVAR_CYCLES
#-DCPU_SHUTDOWN
#-DSPC700_SHUTDOWN
#-fomit-frame-pointer
CFLAGS=$(CCFLAGS)

.SUFFIXES: .o .cpp .c .cc .h .m .i .S .asm
LDLIBS = -L/usr/X11R6/lib

ifdef NETPLAY
all: offsets snes9x ssnes9x s9xserver
else
all: offsets snes9x ssnes9x
endif

#ggisnes9x
#xf86snes9x

$(FXDEPENDS):
	touch $(FXDEPENDS)
	$(RM) $(FXNO_DEPENDS)

offsets: offsets.o
	$(CCC) $(INCLUDES) -o $@ offsets.o
	./offsets >i386/offsets.h

snes9x: $(OBJECTS) unix/x11.o
	$(CCC) $(INCLUDES) -o $@ $(OBJECTS) unix/x11.o $(LDLIBS) -lXext -lX11 -lXxf86dga -lXxf86vm -lgz -lm

xf86snes9x: $(OBJECTS) unix/xf86.o
	$(CCC) $(INCLUDES) -o $@ $(OBJECTS) unix/xf86.o $(LDLIBS) -lXext -lX11 -lXxf86dga -lXxf86vm -lgz -lm
	/bin/chmod u+s xf86snes9x

ssnes9x: $(OBJECTS) unix/svga.o
	$(CCC) $(INCLUDES) -o $@ $(OBJECTS) unix/svga.o $(LDLIBS) -lvga -lvgagl -lgz -lm

gsnes9x: $(OBJECTS) unix/ggi.o
	$(CCC) $(INCLUDES) -o $@ $(OBJECTS) unix/ggi.o $(LDLIBS) -lggi -lgz -lm

s9xserver: $(SERVER_OBJECTS)
	$(CCC) $(INCLUDES) -o $@ $(SERVER_OBJECTS) 

.cpp.o:
	$(CCC) $(INCLUDES) -c $(CCFLAGS) $*.cpp -o $@

.c.o:
	$(CC) $(INCLUDES) -c $(CCFLAGS) $*.c -o $@

.cpp.S:
	$(CCC) $(INCLUDES) -S $(CCFLAGS) $*.cpp -o $@

.cpp.i:
	$(CCC) $(INCLUDES) -E $(CCFLAGS) $*.cpp -o $@

.S.o:
	$(CCC) $(INCLUDES) -c $(CCFLAGS) $*.S -o $@

.S.i:
	$(CCC) $(INCLUDES) -c -E $(CCFLAGS) $*.S -o $@

.asm.o:
	$(NASM) -f elf -i . -i i386 -o $@ $*.asm

clean:
	rm -f $(OBJECTS) offsets.o unix/svga.o unix/x11.o unix/ggi.o unix/xf86.o

#release: CCFLAGS += -DNO_DEBUGGER

release: clean all

ppu.o: $(FXDEPENDS)
cpu.o: $(FXDEPENDS)
memmap.o: $(FXDEPENDS)
globals.o: $(FXDEPENDS)
i386/cpuexec.o: $(FXDEPENDS)
snapshot.o: $(FXDEPENDS)
snaporig.o: $(FXDEPENDS)

i386/cpuexec.o: i386/asmstruc.h i386/offsets.h
i386/cpuops.o: i386/asmstruc.h i386/asmops.h i386/getset.S i386/asmaddr.h i386/offsets.h
i386/spc700.o: i386/asmstruc.h i386/spcops.h i386/offsets.h
cpuexec.o: cpuexec.h cpuops.h snes9x.h snapshot.h gfx.h \
	memmap.h ppu.h debug.h port.h display.h apu.h spc700.h apu.h
cpuops.o: cpuops.h memmap.h snes9x.h spc700.h apu.h \
	cpuaddr.h cpumacro.h debug.h port.h cpuexec.h
debug.o: cpuops.h cpuexec.h snes9x.h \
	memmap.h ppu.h debug.h missing.h port.h display.h apu.h
ppu.o: snes9x.h memmap.h ppu.h missing.h port.h cpuexec.h \
	apu.h spc700.h fxemu.h fxinst.h
dsp1.o: snes9x.h port.h dsp1.h
snapshot.o: snapshot.h memmap.h snes9x.h 65c816.h ppu.h \
	cpuexec.h display.h apu.h spc700.h
snes96.o: port.h snes9x.h memmap.h
memmap.o: cpuexec.h snes9x.h memmap.h ppu.h port.h cheats.h getset.h
unix.o: cpuexec.h snes9x.h port.h snapshot.h display.h apu.h gfx.h cheats.h
x11.o: display.h snes9x.h memmap.h debug.h ppu.h snapshot.h gfx.h
ggi.o: display.h snes9x.h memmap.h debug.h ppu.h snapshot.h gfx.h 
svga.o: display.h snes9x.h memmap.h debug.h ppu.h snapshot.h gfx.h soundux.h
gfx.o: memmap.h snes9x.h ppu.h gfx.h display.h port.h
tile.o: memmap.h snes9x.h ppu.h display.h gfx.h tile.h
spc700.o: spc700.h apu.h apumem.h snes9x.h memmap.h
apu.o: spc700.h apu.h apumem.h snes9x.h soundux.h
soundux.o: snes9x.h soundux.h apu.h
dma.o: ppu.h dma.h memmap.h getset.h snes9x.h port.h apu.h spc700.h
cheats.o: cheats.h snes9x.h port.h memmap.h
fxemu.o: fxemu.h fxinst.h
fxinst.o: fxemu.h fxinst.h
fxdbg.o: fxemu.h fxinst.h
offsets.o: port.h snes9x.h memmap.h ppu.h apu.h cpuexec.h 65c816.h
globals.o: memmap.h spc700.h apu.h cpuexec.h ppu.h cheats.h snes9x.h gfx.h \
	   missing.h dma.h dsp1.h
xf86.o: display.h snes9x.h memmap.h debug.h ppu.h snapshot.h gfx.h
server.o: snes9x.h port.h memmap.h netplay.h
netplay.o: snes9x.h port.h memmap.h netplay.h

## snes9x 1.26

=== Makefile ===
ZSNESFX=1
ASMCPU=1
#SPC700ASM=1
NETPLAY=1
UNZIP=1
GLIDE=1
#GUI=1
THREAD_SOUND=1

ifdef ZSNESFX
FXOBJ=i386/fxemu2b.o i386/fxemu2.o i386/fxemu2c.o i386/fxtable.o i386/sfxproc.o i386/zsnes.o
FXDEFINES=-DZSNES_FX -DEXECUTE_SUPERFX_PER_LINE
FXDEPENDS=zsnes_fx
FXNO_DEPENDS=c_fx
else
FXOBJ=fxinst.o fxemu.o fxdbg.o
FXDEFINES=-DEXECUTE_SUPERFX_PER_LINE
FXDEPENDS=c_fx
FXNO_DEPENDS=zsnes_fx
endif

LINUXDEFINES=-DUSE_DGA_EXTENSION -DUSE_VIDMODE_EXTENSION

ifdef ASMCPU
ifdef SPC700ASM
CPUOBJ=i386/cpuops.o i386/cpuexec.o i386/spc700.o sa1cpu.o
CPUDEFINES=
else
CPUOBJ=i386/cpuops.o i386/cpuexec.o spc700.o i386/sa1ops.o
CPUDEFINES=-DSPC700_C
endif
else
CPUOBJ=cpuops.o cpuexec.o spc700.o sa1cpu.o
CPUDEFINES=
endif

OBJECTS=$(CPUOBJ) cpu.o sa1.o debug.o tile.o \
	gfx.o memmap.o snaporig.o clip.o dsp1.o \
	ppu.o dma.o snes9x.o snapshot.o apu.o soundux.o \
        cheats.o data.o unix/unix.o unix/config.o $(FXOBJ) globals.o

ifdef GUI
GUIOBJS = unix/snes9x_gui.o unix/moc_snes9x_gui.o
GUILIBS = -L$(QTDIR)/lib -lqt
GUIDEFINES = -I$(QTDIR)/include
endif

ifdef NETPLAY
OBJECTS += netplay.o
NETPLAYDEFINES=-DNETPLAY_SUPPORT
SERVER_OBJECTS=server.o
endif

ifdef UNZIP
OBJECTS += loadzip.o unzip/unzip.o unzip/explode.o unzip/unreduce.o unzip/unshrink.o
UNZIPDEFINES=-DUNZIP_SUPPORT
endif

ifdef THREAD_SOUND
CPUDEFINES += -DUSE_THREADS
EXTRALIBS += -lpthread
endif

ifdef GLIDE
GLIDEOBJS = unix/glide.o
GLIDEDEFINES = -DUSE_GLIDE -I/usr/include/glide
GLIDELIBS = -lglide2x
GLIDEDEPENDS=use_glide
GLIDENO_DEPENDS=no_glide
else
GLIDEDEPENDS=no_glide
GLIDENO_DEPENDS=use_glide
endif

MOC = $(QTDIR)/bin/moc
CCC = g++ -fno-rtti
CC = gcc
NASM = nasm

INCLUDES=-I/usr/X11R6/include -I/usr/local/include

OPTIMISE=-O6 -mpentium -fomit-frame-pointer -fno-exceptions
#OPTIMISE=-g -fno-exceptions 
#-DMITSHM 

CCFLAGS = $(OPTIMISE) -DMITSHM \
-Ii386 \
-I. \
-Iunzip \
-DJOYSTICK_SUPPORT \
-DZLIB \
-DNO_INLINE_SET_GET \
-DVAR_CYCLES \
-DDEBUGGER \
-DCPU_SHUTDOWN \
-DSPC700_SHUTDOWN \
$(LINUXDEFINES) \
$(FXDEFINES) \
$(CPUDEFINES) \
$(NETPLAYDEFINES) \
$(UNZIPDEFINES) \
$(GLIDEDEFINES) \
$(GUIDEFINES)

#-DSOUND
#-DDEBUGGER
#-DNO_INLINE_SET_GET
#-DVAR_CYCLES
#-DCPU_SHUTDOWN
#-DSPC700_SHUTDOWN

CFLAGS=$(CCFLAGS)

.SUFFIXES: .o .cpp .c .cc .h .m .i .S .asm
LDLIBS = -L/usr/X11R6/lib frame.o

ifdef NETPLAY
all: offsets snes9x ssnes9x s9xserver
else
all: offsets snes9x ssnes9x
endif

#ggisnes9x
#xf86snes9x

$(FXDEPENDS):
	touch $(FXDEPENDS)
	$(RM) $(FXNO_DEPENDS)

$(GLIDEDEPENDS):
	touch $(GLIDEDEPENDS)
	$(RM) $(GLIDENO_DEPENDS)

offsets: offsets.o
	$(CCC) $(INCLUDES) -o $@ offsets.o
	./offsets >i386/offsets.h

snes9x: $(OBJECTS) unix/x11.o $(GLIDEOBJS) $(GUIOBJS)
	$(CCC) $(INCLUDES) -o $@ $(OBJECTS) $(GLIDEOBJS) unix/x11.o $(GUIOBJS) $(LDLIBS) $(GLIDELIBS) $(GUILIBS) -lXxf86dga -lXxf86vm -lXext -lX11 $(EXTRALIBS) -lz -lm

ssnes9x: $(OBJECTS) unix/svga.o $(GLIDEOBJS) 
	$(CCC) $(INCLUDES) -o $@ $(OBJECTS) $(GLIDEOBJS) unix/svga.o $(LDLIBS) $(GLIDELIBS) -lvga -lvgagl -lz $(EXTRALIBS) -lm

gsnes9x: $(OBJECTS) unix/ggi.o
	$(CCC) $(INCLUDES) -o $@ $(OBJECTS) unix/ggi.o $(LDLIBS) -lggi -lz $(EXTRALIBS) -lm

s9xserver: $(SERVER_OBJECTS)
	$(CCC) $(INCLUDES) -o $@ $(SERVER_OBJECTS) 

.cpp.o:
	$(CCC) $(INCLUDES) -c $(CCFLAGS) $*.cpp -o $@

.c.o:
	$(CC) $(INCLUDES) -c $(CCFLAGS) $*.c -o $@

.cpp.S:
	$(CCC) $(INCLUDES) -S $(CCFLAGS) $*.cpp -o $@

.cpp.i:
	$(CCC) $(INCLUDES) -E $(CCFLAGS) $*.cpp -o $@

.S.o:
	$(CCC) $(INCLUDES) -c $(CCFLAGS) $*.S -o $@

.S.i:
	$(CCC) $(INCLUDES) -c -E $(CCFLAGS) $*.S -o $@

.asm.o:
	$(NASM) -f elf -i. -ii386 -o $@ $*.asm

unix/moc_snes9x_gui.cpp: unix/snes9x_gui.h
	$(MOC) unix/snes9x_gui.h -o $@

clean:
	rm -f $(OBJECTS) offsets.o unix/svga.o unix/x11.o unix/ggi.o unix/xf86.o unix/glide.o

#release: CCFLAGS += -DNO_DEBUGGER

release: clean all

ppu.o: $(FXDEPENDS)
cpu.o: $(FXDEPENDS)
memmap.o: $(FXDEPENDS)
globals.o: $(FXDEPENDS)
i386/cpuexec.o: $(FXDEPENDS)
snapshot.o: $(FXDEPENDS)
snaporig.o: $(FXDEPENDS)

unix/unix.o: $(GLIDEDEPENDS)
unix/x11.o: $(GLIDEDEPENDS)
unix/glide.o: $(GLIDEDEPENDS)
gfx.o: $(GLIDEDEPENDS)

i386/cpuexec.o: i386/asmstruc.h i386/offsets.h
i386/cpuops.o: i386/asmstruc.h i386/asmops.h i386/getset.S i386/asmaddr.h \
		i386/offsets.h
i386/spc700.o: i386/asmstruc.h i386/spcops.h i386/offsets.h
i386/sa1ops.o: i386/offsets.h i386/sa1struc.h i386/sa1addr.h i386/sa1ops.h \
		i386/sa1gs.S
cpuexec.o: cpuexec.h cpuops.h snes9x.h snapshot.h gfx.h sa1.h \
	memmap.h ppu.h debug.h port.h display.h apu.h spc700.h apu.h
cpuops.o: cpuops.h memmap.h snes9x.h spc700.h apu.h \
	cpuaddr.h cpumacro.h debug.h port.h cpuexec.h
debug.o: cpuops.h cpuexec.h snes9x.h sa1.h \
	memmap.h ppu.h debug.h missing.h port.h display.h apu.h
ppu.o: snes9x.h memmap.h ppu.h missing.h port.h cpuexec.h \
	apu.h spc700.h fxemu.h fxinst.h sa1.h
dsp1.o: snes9x.h port.h dsp1.h
snapshot.o: snapshot.h memmap.h snes9x.h 65c816.h ppu.h \
	cpuexec.h display.h apu.h spc700.h soundux.h sa1.h
snes96.o: port.h snes9x.h memmap.h
memmap.o: cpuexec.h snes9x.h memmap.h ppu.h port.h cheats.h getset.h apu.h \
	  spc700.h sa1.h
unix.o: cpuexec.h snes9x.h port.h snapshot.h display.h apu.h gfx.h cheats.h
x11.o: display.h snes9x.h memmap.h debug.h ppu.h snapshot.h gfx.h
ggi.o: display.h snes9x.h memmap.h debug.h ppu.h snapshot.h gfx.h 
svga.o: display.h snes9x.h memmap.h debug.h ppu.h snapshot.h gfx.h soundux.h
gfx.o: memmap.h snes9x.h ppu.h gfx.h display.h port.h
tile.o: memmap.h snes9x.h ppu.h display.h gfx.h tile.h 3d.h
spc700.o: spc700.h apu.h apumem.h snes9x.h memmap.h
sa1.o: snes9x.h memmap.h ppu.h cpuexec.h dma.h sa1.h cpuops.cpp 65c816.h
sa1cpu.o: snes9x.h memmap.h ppu.h cpuexec.h dma.h sa1.h cpuops.cpp 65c816.h
apu.o: spc700.h apu.h apumem.h snes9x.h soundux.h
soundux.o: snes9x.h soundux.h apu.h
dma.o: ppu.h dma.h memmap.h getset.h snes9x.h port.h apu.h spc700.h
cheats.o: cheats.h snes9x.h port.h memmap.h
fxemu.o: fxemu.h fxinst.h
fxinst.o: fxemu.h fxinst.h
fxdbg.o: fxemu.h fxinst.h
offsets.o: port.h snes9x.h memmap.h ppu.h apu.h cpuexec.h 65c816.h sa1.h
globals.o: memmap.h spc700.h apu.h cpuexec.h ppu.h cheats.h snes9x.h gfx.h \
	   missing.h dma.h dsp1.h soundux.h sa1.h
xf86.o: display.h snes9x.h memmap.h debug.h ppu.h snapshot.h gfx.h
server.o: snes9x.h port.h memmap.h netplay.h
netplay.o: snes9x.h port.h memmap.h netplay.h
snaporig.o: cpuexec.h
unix/x11.o: snes9x.h port.h
unix/glide.o: snes9x.h port.h 3d.h
unix/x11.o: unix/snes9x_gui.h
unix/snes9x_gui.o: unix/snes9x_gui.h

## snes9x 1.39

=== Makefile ===
--- 
+++ 
@@ -1,11 +1,14 @@
 ZSNESFX=1
+ZSNESC4=1
 ASMCPU=1
 #SPC700ASM=1
 NETPLAY=1
 UNZIP=1
-GLIDE=1
+#GLIDE=1
+#OPENGL=1
 #GUI=1
 THREAD_SOUND=1
+ASMKREED=1
 
 ifdef ZSNESFX
 FXOBJ=i386/fxemu2b.o i386/fxemu2.o i386/fxemu2c.o i386/fxtable.o i386/sfxproc.o i386/zsnes.o
@@ -19,25 +22,47 @@
 FXNO_DEPENDS=zsnes_fx
 endif
 
+ifdef ZSNESC4
+C4OBJ=i386/c4.o i386/zsnesc4.o c4.o
+C4DEFINES=-DZSNES_C4
+C4DEPENDS=zsnes_c4
+C4NO_DEPENDS=c_c4
+else
+C4OBJ=c4.o c4emu.o
+C4DEFINES=
+C4DEPENDS=c_c4
+C4NO_DEPENDS=zsnes_c4
+endif
+
 LINUXDEFINES=-DUSE_DGA_EXTENSION -DUSE_VIDMODE_EXTENSION
 
+ifdef SPC700ASM
+SOUNDOBJ=spctool/spc700.o spctool/dsp.o spctool.o spctool/soundmod.o spc.o
+SOUNDDEFINES=-DSPCTOOL
+else
+SOUNDOBJ=spc700.o soundux.o apu.o i386/spc.o
+SOUNDDEFINES=-DSPC700_C
+endif
+
 ifdef ASMCPU
-ifdef SPC700ASM
-CPUOBJ=i386/cpuops.o i386/cpuexec.o i386/spc700.o sa1cpu.o
-CPUDEFINES=
-else
-CPUOBJ=i386/cpuops.o i386/cpuexec.o spc700.o i386/sa1ops.o
-CPUDEFINES=-DSPC700_C
-endif
-else
-CPUOBJ=cpuops.o cpuexec.o spc700.o sa1cpu.o
-CPUDEFINES=
-endif
-
-OBJECTS=$(CPUOBJ) cpu.o sa1.o debug.o tile.o \
+CPUOBJ=i386/cpuops.o i386/cpuexec.o i386/sa1ops.o
+else
+CPUOBJ=cpuops.o cpuexec.o sa1cpu.o
+endif
+
+ifdef ASMKREED
+KREEDOBJ=i386/2xSaImmx.o i386/bilinear.o 2xsai.o
+KREEDDEFINES=-DMMX
+else
+KREEDDEFINES=
+KREEDOBJ=2xsai.o
+endif
+
+OBJECTS=$(CPUOBJ) $(SOUNDOBJ) apudebug.o $(FXOBJ) $(C4OBJ) \
+	cpu.o sa1.o debug.o sdd1.o tile.o srtc.o \
 	gfx.o memmap.o snaporig.o clip.o dsp1.o \
-	ppu.o dma.o snes9x.o snapshot.o apu.o soundux.o \
-        cheats.o data.o unix/unix.o unix/config.o $(FXOBJ) globals.o
+	ppu.o dma.o snes9x.o snapshot.o \
+        cheats.o cheats2.o data.o unix/unix.o unix/config.o globals.o
 
 ifdef GUI
 GUIOBJS = unix/snes9x_gui.o unix/moc_snes9x_gui.o
@@ -46,7 +71,7 @@
 endif
 
 ifdef NETPLAY
-OBJECTS += netplay.o
+OBJECTS += netplay.o server.o
 NETPLAYDEFINES=-DNETPLAY_SUPPORT
 SERVER_OBJECTS=server.o
 endif
@@ -72,6 +97,17 @@
 GLIDENO_DEPENDS=use_glide
 endif
 
+ifdef OPENGL
+OPENGLOBJS = unix/opengl.o
+OPENGLDEFINES = -DUSE_OPENGL
+OPENGLLIBS = -lGL -lGLU -ldl
+OPENGLDEPENDS=use_opengl
+OPENGLNO_DEPENDS=no_opengl
+else
+OPENGLDEPENDS=no_opengl
+OPENGLNO_DEPENDS=use_opengl
+endif
+
 MOC = $(QTDIR)/bin/moc
 CCC = g++ -fno-rtti
 CC = gcc
@@ -79,8 +115,9 @@
 
 INCLUDES=-I/usr/X11R6/include -I/usr/local/include
 
-OPTIMISE=-O6 -mpentium -fomit-frame-pointer -fno-exceptions
-#OPTIMISE=-g -fno-exceptions 
+OPTIMISE= -O6 -mpentium -fomit-frame-pointer -fno-exceptions -Wall -W -pedantic -pipe 
+
+#OPTIMISE=-g -fno-exceptions
 #-DMITSHM 
 
 CCFLAGS = $(OPTIMISE) -DMITSHM \
@@ -89,18 +126,23 @@
 -Iunzip \
 -DJOYSTICK_SUPPORT \
 -DZLIB \
--DNO_INLINE_SET_GET \
 -DVAR_CYCLES \
 -DDEBUGGER \
 -DCPU_SHUTDOWN \
 -DSPC700_SHUTDOWN \
+-DOLD_COLOUR_BLENDING \
 $(LINUXDEFINES) \
 $(FXDEFINES) \
+$(C4DEFINES) \
 $(CPUDEFINES) \
+$(SOUNDDEFINES) \
 $(NETPLAYDEFINES) \
 $(UNZIPDEFINES) \
 $(GLIDEDEFINES) \
-$(GUIDEFINES)
+$(OPENGLDEFINES) \
+$(GUIDEFINES) \
+$(KREEDDEFINES) \
+-DNO_INLINE_SET_GET
 
 #-DSOUND
 #-DDEBUGGER
@@ -111,14 +153,10 @@
 
 CFLAGS=$(CCFLAGS)
 
-.SUFFIXES: .o .cpp .c .cc .h .m .i .S .asm
-LDLIBS = -L/usr/X11R6/lib frame.o
-
-ifdef NETPLAY
-all: offsets snes9x ssnes9x s9xserver
-else
+.SUFFIXES: .o .cpp .c .cc .h .m .i .S .asm .obj
+LDLIBS = -L/usr/X11R6/lib
+
 all: offsets snes9x ssnes9x
-endif
 
 #ggisnes9x
 #xf86snes9x
@@ -127,16 +165,24 @@
 	touch $(FXDEPENDS)
 	$(RM) $(FXNO_DEPENDS)
 
+$(C4DEPENDS):
+	touch $(C4DEPENDS)
+	$(RM) $(C4_NODEPENDS)
+
 $(GLIDEDEPENDS):
 	touch $(GLIDEDEPENDS)
 	$(RM) $(GLIDENO_DEPENDS)
 
+$(OPENGLDEPENDS):
+	touch $(OPENGLDEPENDS)
+	$(RM) $(OPENGLNO_DEPENDS)
+
 offsets: offsets.o
 	$(CCC) $(INCLUDES) -o $@ offsets.o
 	./offsets >i386/offsets.h
 
-snes9x: $(OBJECTS) unix/x11.o $(GLIDEOBJS) $(GUIOBJS)
-	$(CCC) $(INCLUDES) -o $@ $(OBJECTS) $(GLIDEOBJS) unix/x11.o $(GUIOBJS) $(LDLIBS) $(GLIDELIBS) $(GUILIBS) -lXxf86dga -lXxf86vm -lXext -lX11 $(EXTRALIBS) -lz -lm
+snes9x: $(OBJECTS) unix/x11.o $(GLIDEOBJS) $(OPENGLOBJS) $(GUIOBJS) $(KREEDOBJ)
+	$(CCC) $(INCLUDES) -o $@ $(OBJECTS) $(GLIDEOBJS) $(OPENGLOBJS) $(KREEDOBJ) unix/x11.o $(GUIOBJS) $(LDLIBS) $(GLIDELIBS) $(OPENGLLIBS) $(GUILIBS) -lXxf86dga -lXxf86vm -lXext -lX11 $(EXTRALIBS) -lz -lm
 
 ssnes9x: $(OBJECTS) unix/svga.o $(GLIDEOBJS) 
 	$(CCC) $(INCLUDES) -o $@ $(OBJECTS) $(GLIDEOBJS) unix/svga.o $(LDLIBS) $(GLIDELIBS) -lvga -lvgagl -lz $(EXTRALIBS) -lm
@@ -166,7 +212,10 @@
 	$(CCC) $(INCLUDES) -c -E $(CCFLAGS) $*.S -o $@
 
 .asm.o:
-	$(NASM) -f elf -i. -ii386 -o $@ $*.asm
+	$(NASM) -f elf $(FXDEFINES) -i. -ii386 -o $@ $*.asm
+
+.obj.o:
+	cp $*.obj $*.o
 
 unix/moc_snes9x_gui.cpp: unix/snes9x_gui.h
 	$(MOC) unix/snes9x_gui.h -o $@
@@ -186,10 +235,11 @@
 snapshot.o: $(FXDEPENDS)
 snaporig.o: $(FXDEPENDS)
 
-unix/unix.o: $(GLIDEDEPENDS)
-unix/x11.o: $(GLIDEDEPENDS)
+unix/unix.o: $(GLIDEDEPENDS) $(OPENGLDEPENDS)
+unix/x11.o: $(GLIDEDEPENDS) $(OPENGLDEPENDS)
 unix/glide.o: $(GLIDEDEPENDS)
-gfx.o: $(GLIDEDEPENDS)
+gfx.o: $(GLIDEDEPENDS) $(OPENGLDEPENDS)
+unix/opengl.o: $(OPENGLDEPENDS)
 
 i386/cpuexec.o: i386/asmstruc.h i386/offsets.h
 i386/cpuops.o: i386/asmstruc.h i386/asmops.h i386/getset.S i386/asmaddr.h \
@@ -201,14 +251,14 @@
 	memmap.h ppu.h debug.h port.h display.h apu.h spc700.h apu.h
 cpuops.o: cpuops.h memmap.h snes9x.h spc700.h apu.h \
 	cpuaddr.h cpumacro.h debug.h port.h cpuexec.h
-debug.o: cpuops.h cpuexec.h snes9x.h sa1.h \
+debug.o: cpuops.h cpuexec.h snes9x.h sa1.h cheats.h \
 	memmap.h ppu.h debug.h missing.h port.h display.h apu.h
 ppu.o: snes9x.h memmap.h ppu.h missing.h port.h cpuexec.h \
 	apu.h spc700.h fxemu.h fxinst.h sa1.h
 dsp1.o: snes9x.h port.h dsp1.h
 snapshot.o: snapshot.h memmap.h snes9x.h 65c816.h ppu.h \
 	cpuexec.h display.h apu.h spc700.h soundux.h sa1.h
-snes96.o: port.h snes9x.h memmap.h
+snes96.o: port.h snes9x.h memmap.h cheats.h
 memmap.o: cpuexec.h snes9x.h memmap.h ppu.h port.h cheats.h getset.h apu.h \
 	  spc700.h sa1.h
 unix.o: cpuexec.h snes9x.h port.h snapshot.h display.h apu.h gfx.h cheats.h

## snes9x 1.52

=== debian/changelog ===
snes9x (1:1.52-1) unstable; urgency=low

  * QA upload.
  * New upstream release (Closes: #432922, #472764).
  * Switch to dpkg-source 3.0 (quilt) format and drop dpatch.
  * Switch to dh 7.
  * Wrap, sort, and cleanup Build-Depends (Closes: #575861).
  * Fix typo in Build-Depends (Closes: #573708).
  * Enable screenshot support (Closes: #563581).
  * Drop unrequired patches.
  * Drop unused debian/snes9x-opengl.* files.
  * Bump Standards-Version to 3.8.4.
  * Add Homepage field.
  * Add snes9x-gtk package for GTK+ port.

 -- Benjamin Drung <bdrung@ubuntu.com>  Tue, 30 Mar 2010 13:41:46 +0200

snes9x (1:1.5-1) unstable; urgency=medium

  * New Upstream
    * Adds AMD64 Support. (Closes: #384404)
  * Remove all previous patches. They are incorporated in Upstream,
    overridden or useless.
  * Drop -opengl package. Upstream currently does not support the OpenGL
    version. There is still hope for 1.51.

 -- Alain Schroeder <alain@debian.org>  Sun, 20 Oct 2006 14:55:39 +0100

snes9x (1.43-3) unstable; urgency=medium

  * Replace build-dependency on xlibs-dev with an explicit
    build-dependency on each required package. (Closes: #346932)
  * Depend on xlibmesa-gl-dev | libgl-dev, xlibmesa-glu-dev | libglu-dev
    instead of xlibmesa-dev, which no longer exists. (Closes: #327307)
  * Thanks to Steinar H. Gunderson for the two above. (Closes: #349230)
  * There still is no good OpenGL Patch. I gave up on it. Anybody?
  * Remove snes9x-1.43-src/snes9x/config.cache for clean sources.

 -- Alain Schroeder <alain@debian.org>  Sun, 22 Jan 2006 18:55:46 +0100

snes9x (1.43-2) unstable; urgency=low

  * Fix build on AMD64 (closes: #297287)
  * Add missing Build-Deps (closes: #322456)
  * Fix build on !i386 (closes: #322455)
  * Add OpenGL patch (closes: #138416, #286123)

 -- Alain Schroeder <alain@debian.org>  Wed,  7 Sep 2005 13:31:07 +0200

snes9x (1.43-1) experimental; urgency=low

  * New Upstream.
  * Dropped keymap patch due to heavy changes in the source.
  * Added a patch from Jeff Williams so joystick axis can be chosen freely.

 -- Alain Schroeder <alain@debian.org>  Sat,  8 Jan 2005 17:29:32 +0100

snes9x (1.42-2) unstable; urgency=low

  * Fix Build-Dependencies: xlib6g-dev => xlibs-dev (closes: #228374)

 -- Alain Schroeder <alain@debian.org>  Tue, 24 Feb 2004 23:18:23 +0100

snes9x (1.42-1) unstable; urgency=low

  * "Mario In Detox" Release
  * New Upstream (closes: #212720)
  * Dropped SVGA and Glide Version, because they are no longer supported by
    upstream.
  * Included Patch from Terran Melconian <terran@consistent.org> to support
    more than two joypads (closes: #195764)
    *** Patchfile: 01_4joypads
  * Include better keymap (closes: #181864, #181865)
  * The copyright file is more readable now.
  * Reworked the complete build system using dpatch. Now all patches
    have their own files.
    *** 02_fix_ntsc_help: Fix ntsc help message
    *** 03_fix_loading_some_roms: Fix some ROM loading anomalies
    *** 10_keymap: Allow keymap modification
  * OpenGL Target is still included, since people reported to me, that it
    works fine with their NVidia cards - it does not work with my card though

 -- Alain Schroeder <alain@debian.org>  Sun,  4 Jan 2004 01:12:08 +0100

snes9x (1.39-8) unstable; urgency=low

  * Exclude DGA specific defines, if we build for 3dfx (Closes: #144463).
  * Add the OpenGL Version again, since at least on nVidia cards it works
    fine. (Closes: #145750)
  * Thrown away some useless stuff from the OpenGL's README.Debian.

 -- Alain Schroeder <alain@debian.org>  Sun,  5 May 2002 20:42:02 +0200

snes9x (1.39-7) unstable; urgency=high

  * Removed the OpenGL Version, since it didn't work. I swear it worked
    earlier - it was much slower than the X11 Version, but it worked.
  * Urgency high to get it into woody.
  * Removed s9xserver manpage from the debian directory - it's just useless
    data at the moment.

 -- Alain Schroeder <alain@debian.org>  Sat, 20 Apr 2002 12:31:02 +0200

snes9x (1.39-6) unstable; urgency=low

  * I partially applied a patch from Brad, which caused a big mess. I reversed
    it and applied another patch from Brad to fix the problem in tile.cpp
    without the big mess.

 -- Alain Schroeder <alain@debian.org>  Thu, 14 Mar 2002 13:21:57 +0100

snes9x (1.39-5) unstable; urgency=low

  * Fix check for MSB_FIRST in 2xsai.cpp and unix/unix.cpp (Fixes building
    on big endian machines).
  * All packages now depend on snes9x-common with the same version number.

 -- Alain Schroeder <alain@debian.org>  Wed, 13 Mar 2002 14:45:25 +0100

snes9x (1.39-4) unstable; urgency=low

  * Applied another patch from andi <andi@fischlustig.de> to fix big endian
    issues with the image processing filters and make it use MSB_FIRST.
    (2xsai.cpp)
  * Fix a typo with GETS_STREAM und GETC_STREAM, which I introduced, while
    applying Brads Patches. (snes9x.h)
  * Fixed output, if /usr/share/snes9x/snes9x.ctl was loaded - it reported
    another file was loaded. (controls.cpp)
  * Fixed typo in debian/Makefile, so the svgalib uses the svgalib keymap
    (Thanks to Brad).
  * Also changed -mpentium to -mcpu=pentium in debian/rules (Thanks to Brad).
  * Added much more from Brad Jorsch <anomie@users.sourceforge.net> patch:
    * Snapshot the when exit/load snapshot/reset is pressed. (cpu.cpp,
      snapshot.cpp, snapshot.h, unix/unix.cpp)
    * Calculate PPU.FirstSprite differently.                 (ppu.cpp, ppu.h)
    * translate some fixes from i386/cpuops.S to cpuops.cpp.
    * Fix loading certain types of ROMs from a zip file. (loadzip.cpp)
    * Fix some tile bugs. (tile.cpp)
    * Don't open Sounddevice, if sound is disabled. (unix/unix.cpp)
    * Support IPS Patches (memmap.cpp)
  * Modified the search in zip files for IPS Patches, so snes9x now test
    every file.

 -- Alain Schroeder <alain@debian.org>  Tue, 12 Mar 2002 15:32:24 +0100

snes9x (1.39-3) unstable; urgency=low



=== debian/control ===
Source: snes9x
Section: non-free/games
Priority: optional
Build-Depends: debhelper (>= 7.0.50~),
               intltool (>= 0.40.1),
               libgl1-mesa-dev | libgl-dev,
               libglade2-dev,
               libglu1-mesa-dev | libglu-dev,
               libgtk2.0-dev (>= 2.10),
               libpulse-dev,
               libsdl1.2-dev,
               libx11-dev,
               libxml2-dev,
               libxv-dev,
               nasm [i386],
               portaudio19-dev
Maintainer: Debian QA Group <packages@qa.debian.org>
Homepage: http://www.snes9x.com/
Standards-Version: 3.8.4

Package: snes9x-x
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: snes9x-common, snes9x-server, snes9x-fx, snes9x-svga, snes9x-opengl
Suggests: zsnes
Description: X binaries for snes9x - Super NES Emulator
 Snes9x is a portable, freeware Super Nintendo Entertainment System (SNES)
 emulator. It basically allows you to play most games designed for the SNES
 and Super Famicom Nintendo game systems on your PC or Workstation; they
 include some real gems that were only ever released in Japan.

Package: snes9x-gtk
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GTK+ port of Snes9x - Super NES Emulator
 Snes9x is a portable, freeware Super Nintendo Entertainment System (SNES)
 emulator. It basically allows you to play most games designed for the SNES
 and Super Famicom Nintendo game systems on your PC or Workstation; they
 include some real gems that were only ever released in Japan.
 .
 This package contains a graphical user interface using GTK+.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh --sourcedirectory=gtk $@

override_dh_auto_configure:
	dh_auto_configure --sourcedirectory=unix -- --enable-netplay

override_dh_auto_build:
	dh_auto_build --sourcedirectory=unix
	cd unix && $(MAKE) clean
	dh_auto_configure --sourcedirectory=gtk -- --bindir=/usr/games
	dh_auto_build --sourcedirectory=gtk

override_dh_install:
	dh_install
	mkdir -p debian/snes9x-x/etc/snes9x
	install -m 644 docs/snes9x.conf.default debian/snes9x-x/etc/snes9x/snes9x.conf

override_dh_installchangelogs:
	dh_installchangelogs docs/changes.txt

=== debian/watch ===
version=3
http://code.google.com/p/snes9x-gtk/downloads/list \
  http://snes9x-gtk.googlecode.com/files/snes9x-([0-9.]+)-src\.tar\.bz2
